program icz05_MoreText;

uses
  Windows,
  Messages;

const
  ClassName  = 'SimpleWinClass';
  AppName    = 'Our First Window';
  TestString = 'Win32 assembly is great and easy!';
  FontName   = 'script';

function WndProc(hWnd: HWND; uMsg: UINT; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
var
  dc  : HDC;
  ps  : TPaintStruct;
  font: HFONT;
begin
  Result := 0;
  case uMsg of
    WM_DESTROY:
      PostQuitMessage(0);
    WM_PAINT:
      begin
        dc := BeginPaint(hWnd, ps);
        font := SelectObject(dc, CreateFont(24, 16, 0, 0, 400, 0, 0, 0,
          OEM_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
          DEFAULT_PITCH or FF_SCRIPT, FontName));
        SetTextColor(dc, RGB(200, 200, 50));
        SetBkColor(dc, RGB(0, 0, 255));
        TextOut(dc, 0, 0, TestString, lstrlen(TestString));
        SelectObject(dc, font);
        EndPaint(hWnd, ps);
      end;
  else
    Result := DefWindowProc(hWnd, uMsg, wParam, lParam);
  end;
end;

var
  wc: TWndClassEx = (
    cbSize       : SizeOf(TWndClassEx);
    style        : CS_HREDRAW or CS_VREDRAW;
    lpfnWndProc  : @WndProc;
    cbClsExtra   : 0;
    cbWndExtra   : 0;
    hbrBackground: COLOR_WINDOW + 1;
    lpszMenuName : nil;
    lpszClassName: ClassName;
    hIconSm      : 0;
  );
  msg: TMsg;
  wnd: HWND;

begin
  wc.hInstance := HInstance;
  wc.hIcon     := LoadIcon(0, IDI_APPLICATION);
  wc.hCursor   := LoadCursor(0, IDC_ARROW);
  RegisterClassEx(wc);
  wnd := CreateWindowEx(0, ClassName, AppName, WS_OVERLAPPEDWINDOW,
    Integer(CW_USEDEFAULT), Integer(CW_USEDEFAULT), Integer(CW_USEDEFAULT),
    Integer(CW_USEDEFAULT), 0, 0, HInstance, nil);
  ShowWindow(wnd, SW_SHOWNORMAL);
  UpdateWindow(wnd);
  while True do
  begin
    if not GetMessage(msg, 0, 0, 0) then
      Break;
    TranslateMessage(msg);
    DispatchMessage(msg);
  end;
  ExitCode := msg.wParam;
end.