program icz09_Controls;

{$R 'Resource.res' 'Resource.rc'}

uses
  Windows,
  Messages;

const
  IDM_HELLO   = 1;
  IDM_CLEAR   = 2;
  IDM_GETTEXT = 3;
  IDM_EXIT    = 4;

const
  ButtonID = 1;
  EditID   = 2;

const
  ClassName       = 'SimpleWinClass';
  AppName         = 'Our First Window';
  MenuName        = 'FirstMenu';
  ButtonClassName = 'button';
  ButtonText      = 'My First Button';
  EditClassName   = 'edit';
  TestString      = 'Wow! I''m in an edit box now';

var
  hwndButton: HWND;
  hwndEdit  : HWND;
  buffer    : array [0..511] of Char;

function WndProc(hWnd: HWND; uMsg: UINT; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
begin
  Result := 0;
  case uMsg of
    WM_DESTROY:
      PostQuitMessage(0);
    WM_CREATE:
      begin
        hwndEdit := CreateWindowEx(WS_EX_CLIENTEDGE, EditClassName, nil,
          WS_CHILD or WS_VISIBLE or WS_BORDER or ES_LEFT or ES_AUTOHSCROLL,
          50, 35, 200, 25, hWnd, EditID, HInstance, nil);
        SetFocus(hwndEdit);
        hwndButton := CreateWindowEx(0, ButtonClassName, ButtonText, WS_CHILD or
          WS_VISIBLE or BS_DEFPUSHBUTTON, 75, 70, 140, 25, hWnd, ButtonID,
          HInstance, nil);
      end;
    WM_COMMAND:
      begin
        if lParam = 0 then
        begin
          case LoWord(wParam) of
            IDM_HELLO:
              begin
                SetWindowText(hwndEdit, TestString);
                SendMessage(hwndEdit, WM_KEYDOWN, VK_END, 0);
              end;
            IDM_CLEAR:
              SetWindowText(hwndEdit, nil);
            IDM_GETTEXT:
              begin
                GetWindowText(hwndEdit, buffer, 512);
                MessageBox(0, buffer, AppName, MB_OK);
              end;
          else
            DestroyWindow(hWnd);
          end;
        end else
          if LoWord(wParam) = ButtonID then
            if HiWord(wParam) = BN_CLICKED then
              SendMessage(hWnd, WM_COMMAND, IDM_GETTEXT, 0);
      end;
  else
    Result := DefWindowProc(hWnd, uMsg, wParam, lParam);
  end;
end;

var
  wc: TWndClassEx = (
    cbSize       : SizeOf(TWndClassEx);
    style        : CS_HREDRAW or CS_VREDRAW;
    lpfnWndProc  : @WndProc;
    cbClsExtra   : 0;
    cbWndExtra   : 0;
    hbrBackground: COLOR_WINDOW + 1;
    lpszMenuName : MenuName;
    lpszClassName: ClassName;
    hIconSm      : 0;
  );
  msg: TMsg;
  wnd: HWND;

begin
  wc.hInstance := HInstance;
  wc.hIcon     := LoadIcon(0, IDI_APPLICATION);
  wc.hCursor   := LoadCursor(0, IDC_ARROW);
  RegisterClassEx(wc);
  wnd := CreateWindowEx(0, ClassName, AppName, WS_OVERLAPPEDWINDOW,
    Integer(CW_USEDEFAULT), Integer(CW_USEDEFAULT), 300, 200, 0, 0, HInstance,
    nil);
  ShowWindow(wnd, SW_SHOWNORMAL);
  UpdateWindow(wnd);
  while True do
  begin
    if not GetMessage(msg, 0, 0, 0) then
      Break;
    TranslateMessage(msg);
    DispatchMessage(msg);
  end;
  ExitCode := msg.wParam;
end.