program icz10_DialogBox_01;

{$R 'Resource.res' 'Resource.rc'}

uses
  Windows,
  Messages;

const
  IDC_EDIT    = 3000;
  IDC_BUTTON  = 3001;
  IDC_EXIT    = 3002;
  IDM_GETTEXT = 32000;
  IDM_CLEAR   = 32001;
  IDM_EXIT    = 32002;

const
  ClassName  = 'DLGCLASS';
  MenuName   = 'MyMenu';
  DlgName    = 'MyDialog';
  AppName    = 'Our First Dialog Box';
  TestString = 'Wow! I''m in an edit box now';

var
  buffer: array [0..511] of Char;

function WndProc(hWnd: HWND; uMsg: UINT; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
begin
  Result := 0;
  case uMsg of
    WM_CREATE:
      SetDlgItemText(hWnd, IDC_EDIT, AppName);
    WM_DESTROY:
      PostQuitMessage(0);
    WM_COMMAND:
      if lParam = 0 then
      begin
        case LoWord(wParam) of
          IDM_GETTEXT:
            begin
              GetDlgItemText(hWnd, IDC_EDIT, buffer, 512);
              MessageBox(0, buffer, AppName, MB_OK);
            end;
          IDM_CLEAR:
            SetDlgItemText(hWnd, IDC_EDIT, nil);
        else
          DestroyWindow(hWnd);
        end;
      end else
        if HiWord(wParam) = BN_CLICKED then
        begin
          case LoWord(wParam) of
            IDC_BUTTON:
              SetDlgItemText(hWnd, IDC_EDIT, TestString);
            IDC_EXIT:
              SendMessage(hWnd, WM_COMMAND, IDM_EXIT, 0);
          end;
        end;
  else
    Result := DefWindowProc(hWnd, uMsg, wParam, lParam);
  end;
end;

var
  wc: TWndClassEx = (
    cbSize       : SizeOf(TWndClassEx);
    style        : CS_HREDRAW or CS_VREDRAW;
    lpfnWndProc  : @WndProc;
    cbClsExtra   : 0;
    cbWndExtra   : DLGWINDOWEXTRA;
    hbrBackground: COLOR_BTNFACE + 1;
    lpszMenuName : MenuName;
    lpszClassName: ClassName;
    hIconSm      : 0;
  );
  msg: TMsg;
  hDlg: HWND;

begin
  wc.hInstance := HInstance;
  wc.hIcon     := LoadIcon(0, IDI_APPLICATION);
  wc.hCursor   := LoadCursor(0, IDC_ARROW);
  RegisterClassEx(wc);
  hDlg := CreateDialogParam(HInstance, DlgName, 0, nil, 0);
  SetFocus(GetDlgItem(hDlg, IDC_EDIT));
  ShowWindow(hDlg, SW_SHOWNORMAL);
  UpdateWindow(hDlg);
  while True do
  begin
    if not GetMessage(msg, 0, 0, 0) then
      Break;
    if not IsDialogMessage(hDlg, msg) then
    begin
      TranslateMessage(msg);
      DispatchMessage(msg);
    end;
  end;
  ExitCode := msg.wParam;
end.