program icz12_MMandFileIO;

{$R 'Resource.res' 'Resource.rc'}

uses
  Windows,
  Messages,
  CommDlg;

const
  IDM_OPEN = 1;
  IDM_SAVE = 2;
  IDM_EXIT = 3;

const
  EditID = 1;

const
  ClassName    = 'Win32ASMEditClass';
  AppName      = 'Win32 ASM Edit';
  EditClass    = 'edit';
  MenuName     = 'FirstMenu';
  FilterString = 'All Files'#0'*.*'#0'Text Files'#0'*.txt'#0#0;

const
  MAXSIZE = 260;
  MEMSIZE = 65535;

var
  ofn   : TOpenFilename;
  buffer: array [0..MAXSIZE - 1] of Char;

var
  hwndEdit     : HWND;
  hFile        : THandle;
  hMemory      : THandle;
  pMemory      : Pointer;
  SizeReadWrite: DWORD;

function WndProc(hWnd: HWND; uMsg: UINT; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
begin
  Result := 0;
  case uMsg of
    WM_CREATE:
      begin
        hwndEdit := CreateWindowEx(0, EditClass, nil, WS_VISIBLE or WS_CHILD or
          ES_LEFT or ES_MULTILINE or ES_AUTOHSCROLL or ES_AUTOVSCROLL, 0, 0, 0,
          0, hWnd, EditID, HInstance, nil);
        SetFocus(hwndEdit);
        ofn.lStructSize := SizeOf(TOpenFilename);
        ofn.hWndOwner   := hWnd;
        ofn.hInstance   := HInstance;
        ofn.lpstrFilter := FilterString;
        ofn.lpstrFile   := buffer;
        ofn.nMaxFile    := MAXSIZE;
      end;
    WM_SIZE:
      MoveWindow(hwndEdit, 0, 0, LoWord(lParam), HiWord(lParam), True);
    WM_DESTROY:
      PostQuitMessage(0);
    WM_COMMAND:
      begin
        if lParam = 0 then
        begin
          case LoWord(wParam) of
            IDM_OPEN:
              begin
                ofn.Flags := OFN_FILEMUSTEXIST or OFN_PATHMUSTEXIST or
                  OFN_LONGNAMES or OFN_EXPLORER or OFN_HIDEREADONLY;
                if GetOpenFileName(ofn) then
                begin
                  hFile := CreateFile(buffer, GENERIC_READ or GENERIC_WRITE,
                    FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING,
                    FILE_ATTRIBUTE_ARCHIVE, 0);
                  hMemory := GlobalAlloc(GMEM_MOVEABLE or GMEM_ZEROINIT,
                    MEMSIZE);
                  pMemory := GlobalLock(hMemory);
                  ReadFile(hFile, pMemory^, MEMSIZE - 1, SizeReadWrite, nil);
                  SendMessage(hwndEdit, WM_SETTEXT, 0, Integer(pMemory));
                  CloseHandle(hFile);
                  GlobalUnlock(DWORD(pMemory));
                  GlobalFree(hMemory);
                end;
                SetFocus(hwndEdit);
              end;
            IDM_SAVE:
              begin
                ofn.Flags := OFN_LONGNAMES or OFN_EXPLORER or OFN_HIDEREADONLY;
                if GetSaveFileName(ofn) then
                begin
                  hFile := CreateFile(buffer, GENERIC_READ or GENERIC_WRITE,
                    FILE_SHARE_READ or FILE_SHARE_WRITE, nil, CREATE_NEW,
                    FILE_ATTRIBUTE_ARCHIVE, 0);
                  hMemory := GlobalAlloc(GMEM_MOVEABLE or GMEM_ZEROINIT,
                    MEMSIZE);
                  pMemory := GlobalLock(hMemory);
                  SizeReadWrite := SendMessage(hwndEdit, WM_GETTEXT,
                    MEMSIZE - 1, Integer(pMemory));
                  WriteFile(hFile, pMemory^, SizeReadWrite, SizeReadWrite, nil);
                  CloseHandle(hFile);
                  GlobalUnlock(DWORD(pMemory));
                  GlobalFree(hMemory);
                end;
                SetFocus(hwndEdit);
              end;
          else
            DestroyWindow(hWnd);
          end;
        end;
      end;
  else
    Result := DefWindowProc(hWnd, uMsg, wParam, lParam);
  end;
end;

var
  wc: TWndClassEx = (
    cbSize       : SizeOf(TWndClassEx);
    style        : CS_HREDRAW or CS_VREDRAW;
    lpfnWndProc  : @WndProc;
    cbClsExtra   : 0;
    cbWndExtra   : 0;
    hbrBackground: COLOR_WINDOW + 1;
    lpszMenuName : MenuName;
    lpszClassName: ClassName;
    hIconSm      : 0;
  );
  msg: TMsg;
  wnd: HWND;

begin
  wc.hInstance := HInstance;
  wc.hIcon     := LoadIcon(0, IDI_APPLICATION);
  wc.hCursor   := LoadCursor(0, IDC_ARROW);
  RegisterClassEx(wc);
  wnd := CreateWindowEx(WS_EX_CLIENTEDGE, ClassName, AppName,
    WS_OVERLAPPEDWINDOW, Integer(CW_USEDEFAULT), Integer(CW_USEDEFAULT), 300,
    200, 0, 0, HInstance, nil);
  ShowWindow(wnd, SW_SHOWNORMAL);
  UpdateWindow(wnd);
  while True do
  begin
    if not GetMessage(msg, 0, 0, 0) then
      Break;
    TranslateMessage(msg);
    DispatchMessage(msg);
  end;
  ExitCode := msg.wParam;
end.