program icz18_CommonCtrl;

uses
  Windows,
  Messages,
  CommCtrl;

const
  IDC_PROGRESS = 1;
  IDC_STATUS   = 2;
  IDC_TIMER    = 3;

const
  ClassName     = 'CommonControlWinClass';
  AppName       = 'Common Control Demo';
  ProgressClass = 'msctls_progress32';
  Message       = 'Finished!';

var
  TimerID     : DWORD = 0;
  hwndProgress: DWORD;
  hwndStatus  : DWORD;
  CurrentStep : DWORD;

function WndProc(hWnd: HWND; uMsg: UINT; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
begin
 Result := 0;
 case uMsg of
   WM_CREATE:
     begin
       hwndProgress := CreateWindowEx(0, ProgressClass, nil, WS_CHILD or
         WS_VISIBLE, 100, 200, 300, 20, hWnd, IDC_PROGRESS, HInstance, nil);
       CurrentStep := 1000;
       SendMessage(hwndProgress, PBM_SETRANGE, 0, Integer(CurrentStep shl 16));
       SendMessage(hwndProgress, PBM_SETSTEP, 10, 0);
       hwndStatus := CreateStatusWindow(WS_CHILD or WS_VISIBLE, nil, hWnd,
         IDC_STATUS);
       TimerID := SetTimer(hWnd, IDC_TIMER, 100, nil);
     end;
   WM_DESTROY:
     begin
       PostQuitMessage(0);
       if TimerID <> 0 then
         KillTimer(hWnd, TimerID);
     end;
   WM_TIMER:
     begin
       SendMessage(hwndProgress, PBM_STEPIT, 0, 0);
       Dec(CurrentStep, 10);
       if CurrentStep = 0 then
       begin
         KillTimer(hWnd, TimerID);
         TimerID := 0;
         SendMessage(hwndStatus, SB_SETTEXT, 0, Integer(PChar(Message)));
         MessageBox(hWnd, Message, AppName, MB_OK or MB_ICONINFORMATION);
         SendMessage(hwndStatus, SB_SETTEXT, 0, 0);
         SendMessage(hwndProgress, PBM_SETPOS, 0, 0);
       end;
     end;
  else
    Result := DefWindowProc(hWnd, uMsg, wParam, lParam);
  end;
end;

var
  wc: TWndClassEx = (
    cbSize       : SizeOf(TWndClassEx);
    style        : CS_HREDRAW or CS_VREDRAW;
    lpfnWndProc  : @WndProc;
    cbClsExtra   : 0;
    cbWndExtra   : 0;
    hbrBackground: COLOR_APPWORKSPACE;
    lpszMenuName : nil;
    lpszClassName: ClassName;
    hIconSm      : 0;
  );
  msg: TMsg;

begin
  InitCommonControls;
  wc.hInstance := HInstance;
  wc.hIcon     := LoadIcon(0, IDI_APPLICATION);
  wc.hCursor   := LoadCursor(0, IDC_ARROW);
  RegisterClassEx(wc);
  CreateWindowEx(WS_EX_CLIENTEDGE, ClassName, AppName, WS_OVERLAPPED or
    WS_CAPTION or WS_SYSMENU or WS_MINIMIZEBOX or WS_MAXIMIZEBOX or WS_VISIBLE,
    Integer(CW_USEDEFAULT), Integer(CW_USEDEFAULT), Integer(CW_USEDEFAULT),
    Integer(CW_USEDEFAULT), 0, 0, HInstance, nil);
  while True do
  begin
    if not GetMessage(msg, 0, 0, 0) then
      Break;
    TranslateMessage(msg);
    DispatchMessage(msg);
  end;
  ExitCode := msg.wParam;
end.