program icz20_Subclassing;

uses
  Windows,
  Messages;

const
  ClassName = 'SubclassWinClass';
  AppName   = 'Subclassing Demo';
  EditClass = 'EDIT';
  Message   = 'You pressed the Enter key in the text box!';

var
  hwndEdit  : DWORD;
  OldWndProc: Pointer;

function EditWndProc(hEdit, uMsg, wParam, lParam:DWORD): DWORD; stdcall;
begin
  Result := 0;
  case uMsg of
    WM_CHAR:
      case Byte(wParam) of
        Byte('0')..Byte('9'),
        Byte('A')..Byte('F'),
        Byte('a')..Byte('f'),
        VK_BACK:
          begin
            if (Byte(wParam) >= Byte('a'))
            and (Byte(wParam) <= Byte('f')) then
              Dec(wParam, $20);
            CallWindowProc(OldWndProc, hEdit, uMsg, wParam, lParam);
          end;
      end;
    WM_KEYDOWN:
      begin
        if Byte(wParam) = VK_RETURN then
        begin
          MessageBox(hEdit, Message, AppName, MB_OK or MB_ICONINFORMATION);
          SetFocus(hEdit);
        end else
          CallWindowProc(OldWndProc, hEdit, uMsg, wParam, lParam);
      end;
  else
    Result := CallWindowProc(OldWndProc, hEdit, uMsg, wParam, lParam);
  end;
end;

function WndProc(hWnd: HWND; uMsg: UINT; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
begin
  Result := 0;
  case uMsg of
    WM_CREATE:
      begin
        hwndEdit := CreateWindowEx(WS_EX_CLIENTEDGE, EditClass, nil, WS_CHILD or
          WS_VISIBLE or WS_BORDER, 20, 20, 300, 25, hWnd, 0, HInstance, nil);
        SetFocus(hwndEdit);
        //-----------------------------------------
        // Subclass it!
        //-----------------------------------------
        OldWndProc := Pointer(SetWindowLong(hwndEdit, GWL_WNDPROC,
          Integer(@EditWndProc)));
      end;
    WM_DESTROY:
      PostQuitMessage(0);
  else
    Result := DefWindowProc(hWnd, uMsg, wParam, lParam);
  end;
end;

var
  wc: TWndClassEx = (
    cbSize       : SizeOf(TWndClassEx);
    style        : CS_HREDRAW or CS_VREDRAW;
    lpfnWndProc  : @WndProc;
    cbClsExtra   : 0;
    cbWndExtra   : 0;
    hbrBackground: COLOR_APPWORKSPACE;
    lpszMenuName : nil;
    lpszClassName: ClassName;
    hIconSm      : 0;
  );
  msg: TMsg;

begin
  wc.hInstance := HInstance;
  wc.hIcon     := LoadIcon(0, IDI_APPLICATION);
  wc.hCursor   := LoadCursor(0, IDC_ARROW);
  RegisterClassEx(wc);
  CreateWindowEx(WS_EX_CLIENTEDGE, ClassName, AppName, WS_OVERLAPPED or
    WS_CAPTION or WS_SYSMENU or WS_MINIMIZEBOX or WS_MAXIMIZEBOX or WS_VISIBLE,
    Integer(CW_USEDEFAULT), Integer(CW_USEDEFAULT), 350, 200, 0, 0, HInstance,
    nil);
  while True do
  begin
    if not GetMessage(msg, 0, 0, 0) then
      Break;
    TranslateMessage(msg);
    DispatchMessage(msg);
  end;
  ExitCode := msg.wParam;
end.