program icz21_Pipe;

{$R 'Resource.res' 'Resource.rc'}

uses
  Windows,
  Messages;

const
  IDR_MAINMENU = 101;
  IDM_ASSEMBLE = 40001;

const
  ClassName          = 'PipeWinClass';
  AppName            = 'One-way Pipe Example';
  EditClass          = 'EDIT';
  CreatePipeError    = 'Error during pipe creation';
  CreateProcessError = 'Error during process creation';
  CommandLine        = 'ml /c /coff /Cp test.asm';

var
  hwndEdit: DWORD;

function WndProc(hWnd: HWND; uMsg: UINT; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
var
  hRead      : DWORD;
  hWrite     : DWORD;
  startupinfo: TStartupInfo;
  pinfo      : TProcessInformation;
  buffer     : array [0..1023] of Char;
  bytesRead  : DWORD;
  sat        : TSecurityAttributes;
begin
  Result := 0;
  case uMsg of
    WM_CREATE:
      hwndEdit := CreateWindowEx(0, EditClass, nil, WS_CHILD or WS_VISIBLE or
        ES_MULTILINE or ES_AUTOHSCROLL or ES_AUTOVSCROLL, 0, 0, 0, 0, hWnd, 0,
        HInstance, nil);
    WM_CTLCOLOREDIT:
      begin
        SetTextColor(wParam, $0000FFFF); // Yellow
        SetBkColor(wParam, $00000000);   // Black
        Result := GetStockObject(BLACK_BRUSH);
      end;
    WM_SIZE:
      MoveWindow(hwndEdit, 0, 0, LoWord(lParam), HiWord(lParam), True);
    WM_COMMAND:
      if (lParam = 0) and (LoWord(wParam) = IDM_ASSEMBLE) then
      begin
        sat.nLength := SizeOf(TSecurityAttributes);
        sat.lpSecurityDescriptor := nil;
        sat.bInheritHandle := True;
        if not CreatePipe(hRead, hWrite, @sat, 0) then
          MessageBox(hWnd, CreatePipeError, AppName, MB_ICONERROR or MB_OK)
        else begin
          startupinfo.cb          := SizeOf(TStartupInfo);
          GetStartupInfo(startupinfo);
          startupinfo.hStdOutput  := hWrite;
          startupinfo.hStdError   := hWrite;
          startupinfo.dwFlags     := STARTF_USESHOWWINDOW or
            STARTF_USESTDHANDLES;
          startupinfo.wShowWindow := SW_HIDE;
          //-------------------------------------------------
          // Create process
          //-------------------------------------------------
          if not CreateProcess(nil, CommandLine, nil, nil, True, 0, nil,
            nil, startupinfo, pinfo) then
            MessageBox(hWnd, CreateProcessError, AppName, MB_ICONERROR or MB_OK)
          else begin
            CloseHandle(hWrite);
            while True do
            begin
              ZeroMemory(@buffer, 1024);
              if not ReadFile(hRead, buffer, 1023, bytesRead, nil) then
                Break
              else begin
                SendMessage(hwndEdit, EM_SETSEL, -1, 0);
                SendMessage(hwndEdit, EM_REPLACESEL, Integer(False),
                  Integer(@buffer));
              end;
            end;
          end;
          CloseHandle(hRead);
        end;
      end;
    WM_DESTROY:
      PostQuitMessage(0);
  else
    Result := DefWindowProc(hWnd, uMsg, wParam, lParam);
  end;
end;

var
  wc: TWndClassEx = (
    cbSize        : SizeOf(TWndClassEx);
    style         : CS_HREDRAW or CS_VREDRAW;
    lpfnWndProc   : @WndProc;
    cbClsExtra    : 0;
    cbWndExtra    : 0;
    hbrBackground : COLOR_APPWORKSPACE;
    lpszMenuName  : PChar(IDR_MAINMENU);
    lpszClassName : ClassName;
    hIconSm       : 0;
  );
  msg: TMsg;

begin
  wc.hInstance := HInstance;
  wc.hIcon     := LoadIcon(0, IDI_APPLICATION);
  wc.hCursor   := LoadCursor(0, IDC_ARROW);
  RegisterClassEx(wc);
  CreateWindowEx(WS_EX_CLIENTEDGE, ClassName, AppName,
    WS_OVERLAPPEDWINDOW or WS_VISIBLE, Integer(CW_USEDEFAULT),
    Integer(CW_USEDEFAULT), 400, 200, 0, 0, HInstance, nil);
  while True do
  begin
    if not GetMessage(msg, 0, 0, 0) then
      Break;
    TranslateMessage(msg);
    DispatchMessage(msg);
  end;
  ExitCode := msg.wParam;
end.