program icz22_Superclassing;

uses
  Windows,
  Messages;

const
  WM_SUPERCLASS = WM_USER + 5;

const
  ClassName = 'SuperclassWinClass';
  AppName   = 'Superclassing Demo';
  EditClass = 'EDIT';
  OurClass  = 'SUPEREDITCLASS';
  Message   = 'You pressed the Enter key in the text box!';

var
  hwndEdit  : array [0..5] of DWORD;
  OldWndProc: Pointer;

function EditWndProc(hEdit, uMsg, wParam, lParam: DWORD): DWORD; stdcall;
var
  NextWindow: HWND;
begin
  Result := 0;
  case uMsg of
    WM_CHAR:
      begin
        case Byte(wParam) of
          Byte('0')..Byte('9'),
          Byte('A')..Byte('F'),
          Byte('a')..Byte('f'),
          VK_BACK:
            begin
              if (Char(wParam) >= 'a')
              and (Char(wParam) <= 'f') then
                Dec(wParam, $20);
              Result := CallWindowProc(OldWndProc, hEdit, uMsg, wParam, lParam);
            end;
        end;
      end;
    WM_KEYDOWN:
      begin
	case Byte(wParam) of
          VK_RETURN:
            begin
              MessageBox(hEdit, Message, AppName, MB_OK or MB_ICONINFORMATION);
              SetFocus(hEdit);
            end;
          VK_TAB:
            begin
              if (GetKeyState(VK_SHIFT) and $80000000 = 0) then
              begin
                NextWindow := GetWindow(hEdit, GW_HWNDNEXT);
                if NextWindow = 0 then
                  NextWindow := GetWindow(hEdit, GW_HWNDFIRST);
              end else begin
                NextWindow := GetWindow(hEdit, GW_HWNDPREV);
                if NextWindow = 0 then
                  NextWindow := GetWindow(hEdit, GW_HWNDLAST);
              end;
              SetFocus(NextWindow);
            end;
        else
          Result := CallWindowProc(OldWndProc, hEdit, uMsg, wParam, lParam);
        end;
      end;
  else
    Result := CallWindowProc(OldWndProc, hEdit, uMsg, wParam, lParam);
  end;
end;

function WndProc(hWnd: HWND; uMsg: UINT; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
var
  wc: TWndClassEx;
  Loop: DWORD;
begin
  Result := 0;
  case uMsg of
    WM_CREATE:
      begin
        wc.cbSize        := SizeOf(TWndClassEx);
        GetClassInfoEx(0, EditClass, wc);
        OldWndProc       := wc.lpfnWndProc;
        wc.lpfnWndProc   := @EditWndProc;
        wc.hInstance     := HInstance;
        wc.lpszClassName := OurClass;
        RegisterClassEx(wc);
        for Loop := 0 to 5 do
          hwndEdit[Loop] := CreateWindowEx(WS_EX_CLIENTEDGE, OurClass, nil,
            WS_CHILD or WS_VISIBLE or WS_BORDER, 20, 25 * (Loop + 1), 300, 25,
            hWnd, 0, HInstance, nil);
        SetFocus(hwndEdit[0]);
      end;
    WM_DESTROY:
      PostQuitMessage(0);
  else
    Result := DefWindowProc(hWnd, uMsg, wParam, lParam);
  end;
end;

var
  wc: TWndClassEx = (
    cbSize       : SizeOf(TWndClassEx);
    style        : CS_HREDRAW or CS_VREDRAW;
    lpfnWndProc  : @WndProc;
    cbClsExtra   : 0;
    cbWndExtra   : 0;
    hbrBackground: COLOR_APPWORKSPACE;
    lpszMenuName : nil;
    lpszClassName: ClassName;
    hIconSm      : 0;
  );
  msg: TMsg;

begin
  wc.hInstance := HInstance;
  wc.hIcon     := LoadIcon(0, IDI_APPLICATION);
  wc.hCursor   := LoadCursor(0, IDC_ARROW);
  RegisterClassEx(wc);
  CreateWindowEx(WS_EX_CLIENTEDGE or WS_EX_CONTROLPARENT, ClassName,
    AppName, WS_OVERLAPPED or WS_CAPTION or WS_SYSMENU or WS_MINIMIZEBOX or
    WS_MAXIMIZEBOX or WS_VISIBLE, Integer(CW_USEDEFAULT),
    Integer(CW_USEDEFAULT), 350, 220, 0, 0, HInstance, nil);
  while True do
  begin
    if not GetMessage(msg, 0, 0, 0) then
      Break;
    TranslateMessage(msg);
    DispatchMessage(msg);
  end;
  ExitCode := msg.wParam;
end.